package com.logicbig.example;

import com.logicbig.uicommon.CoalescedEventUpdater;
import javax.swing.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import java.awt.*;

public class CoalesceEventExample {
    public static void main(String[] args) {
        JLabel displayLabel = new JLabel();
        JTextField inputField = new JTextField();
        addTextListener(inputField, displayLabel);
        JFrame frame = createFrame();
        frame.add(inputField, BorderLayout.NORTH);
        frame.add(displayLabel);
        frame.setLocationRelativeTo(null);
        frame.setVisible(true);
    }

    private static void addTextListener(JTextField inputField, JLabel displayLabel) {
        CoalescedEventUpdater updater = new CoalescedEventUpdater(400, () -> {
            displayLabel.setText(inputField.getText());
        });
        inputField.getDocument().addDocumentListener(new DocumentListener() {
            @Override
            public void insertUpdate(DocumentEvent e) {
                update();
            }

            @Override
            public void removeUpdate(DocumentEvent e) {
                update();
            }

            @Override
            public void changedUpdate(DocumentEvent e) {
                update();
            }

            private void update() {
                updater.update();
            }
        });
    }

    private static JFrame createFrame() {
        JFrame frame = new JFrame("Coalesce Events Example");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(new Dimension(600, 300));
        return frame;
    }
}